<?php

namespace Drupal\video_embed_vkontakte\Plugin\video_embed_field\Provider;

use Drupal\video_embed_field\ProviderPluginBase;
use GuzzleHttp\Exception\RequestException;

/**
 * @VideoEmbedProvider(
 *   id = "vkontakte",
 *   title = @Translation("Vkontakte")
 * )
 */
class Vkontakte extends ProviderPluginBase {

  /**
   * {@inheritdoc}
   */
  public function renderEmbedCode($width, $height, $autoplay) {
    // @todo is it possible use autoplay?
    return [
      '#type' => 'html_tag',
      '#tag' => 'iframe',
      '#attributes' => [
        'width' => $width,
        'height' => $height,
        'frameborder' => '0',
        'allowfullscreen' => 'allowfullscreen',
        'src' => $this->getInput(),
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getRemoteThumbnailUrl() {
    try {
      $response = $this->httpClient->get($this->getInput());
      $data = $response->getBody()->getContents();
      preg_match('/<video id="video_player" poster="(?<img>.*)".*>/U', $data, $matches);
      return isset($matches['img']) ? $matches['img'] : '';
    }
    catch (RequestException $exception) {}
  }

  /**
   * {@inheritdoc}
   */
  public static function getIdFromInput($input) {
    preg_match('/^<iframe.*src="\/\/(?<id>.*)".*<\/iframe>$/U', $input, $matches);

    if (isset($matches['id']) ) {
      return 'https://' . $matches['id'];
    }

    if (preg_match('/^https:\/\/vk\.com\/video_ext.php\?oid=-.*&id=.*&hash.*$/', $input)) {
      return $input;
    }
  }

}
